> ## Documentation Index
> Fetch the complete documentation index at: https://docs.enkryptai.com/llms.txt
> Use this file to discover all available pages before exploring further.

# AI Chat Completions Proxy Endpoint



## OpenAPI

````yaml POST /ai-proxy/chat/completions
openapi: 3.0.0
info:
  title: Enkrypt AI APIs
  version: 2.0.0
servers:
  - url: https://api.enkryptai.com
security:
  - apiKeyAuth: []
tags:
  - name: Guardrails
  - name: Code of Conduct
  - name: Endpoints
  - name: Datasets
  - name: Redteam
  - name: Deployments
  - name: AI Proxy
  - name: Leaderboard
  - name: Archived
  - name: MCP Hub
    description: >-
      MCP Hub vulnerability scanning APIs. Submitting scans (the POST endpoints)
      is open to all authenticated callers. The scan **retrieval** APIs — Get
      Scan Job Status, Get Complete Scan Results, List Scans, and Get MCP Hub
      Scan Statistics (the GET endpoints) — are an **enterprise data-license
      feature**: they require your organization to have MCP Hub API access
      enabled by Enkrypt, otherwise they return `403`. Contact us at
      support@enkryptai.com to enable access.
  - name: MCP Registry Servers
  - name: MCP Gateways
  - name: MCP Playground
paths:
  /ai-proxy/chat/completions:
    post:
      tags:
        - AI Proxy
      summary: AI Chat Completions Proxy Endpoint
      operationId: ai_chat_completions_proxy_endpoint_post
      parameters:
        - name: X-Enkrypt-Deployment
          in: header
          required: true
          schema:
            title: Deployment Name
            type: string
            description: The deployment saved name. E.g. test-deployment-1
            example: test-deployment
        - name: X-Enkrypt-Tags
          in: header
          required: false
          schema:
            title: Tags
            type: string
            description: Comma separated tags for the deployment if any
            example: openai-testing,unit-testing
        - name: X-Enkrypt-Refresh-Cache
          in: header
          required: false
          schema:
            title: Refresh Cache
            type: boolean
            description: Refresh the cache if deployment, policy or model data is stale
            example: false
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/CreateChatCompletionRequest'
            examples:
              example:
                value:
                  messages:
                    - role: user
                      content: hi
        required: true
      responses:
        '200':
          description: Successful Response
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/EnkryptCreateChatCompletionResponse'
              examples:
                example:
                  value:
                    id: 9023e384d9fa3af9
                    object: chat.completion
                    created: 1736923377
                    model: mistralai/Mixtral-8x7B-Instruct-v0.1
                    prompt: []
                    choices:
                      - finish_reason: eos
                        seed: 9320035192991048000
                        logprobs: null
                        index: 0
                        message:
                          role: assistant
                          content: ' Hello! How can I help you today? If you have any questions about a specific topic or just want to chat, feel free to ask. I''m here to provide information and engage in a friendly conversation.'
                          tool_calls: []
                    usage:
                      prompt_tokens: 10
                      completion_tokens: 44
                      total_tokens: 54
                    enkrypt_policy_detections:
                      output_guardrails:
                        details:
                          keyword_detector:
                            detected_counts: {}
                            redacted_text: ' Hello! How can I assist you today?'
                            detected_keywords: {}
                          policy_violation:
                            violating_policy: No Violation Found
                            explanation: No Violation Found.
                          bias:
                            bias_detected: false
                            debiased_text: Hello! How may I help you today?
                          pii:
                            ip_address: {}
                            url: {}
                            pii: {}
                            secrets: {}
                          nsfw:
                            sfw: 0.77364963293076
                            nsfw: 0.14463838934898
                          toxicity:
                            threat: 0.00013719938579015
                            severe_toxicity: 0.00013394378765952
                            obscene: 0.00018259837816004
                            insult: 0.00018637960602064
                            toxicity: 0.00058524927590042
                            identity_hate: 0.00014582877338398
                          injection_attack:
                            safe: '0.998087'
                            attack: '0.001913'
                        summary:
                          keyword_detected: 0
                          policy_violation: 0
                          bias: 0
                          pii: 0
                          nsfw: 0
                          toxicity: {}
                          injection_attack: 0
                      input_guardrails:
                        details:
                          keyword_detector:
                            detected_counts: {}
                            redacted_text: '|'
                            detected_keywords: {}
                          policy_violation:
                            violating_policy: No Violation Found
                            explanation: No Violation Found.
                          bias:
                            bias_detected: false
                            debiased_text: No rephrasing needed.
                          pii:
                            ip_address: {}
                            url: {}
                            pii: {}
                            secrets: {}
                          nsfw:
                            sfw: 0.23262414336205
                            nsfw: 0.75041556358337
                          toxicity:
                            threat: 0.0001007060345728
                            severe_toxicity: 0.00010207855666522
                            obscene: 0.00019277907267679
                            insult: 0.00018571241525933
                            toxicity: 0.0011186309857294
                            identity_hate: 0.00013926414248999
                          injection_attack:
                            safe: '0.999906'
                            attack: '0.000094'
                        summary:
                          keyword_detected: 0
                          policy_violation: 0
                          bias: 0
                          pii: 0
                          nsfw: 1
                          toxicity: {}
                          injection_attack: 0
components:
  schemas:
    CreateChatCompletionRequest:
      type: object
      properties:
        enkrypt_context:
          type: string
          description: >-
            The context for the request if using relevancy or hallucion
            detection in output guardrails
        messages:
          description: >
            A list of messages comprising the conversation so far. Depending on
            the

            [model](/docs/models) you use, different message types (modalities)
            are

            supported, like [text](/docs/guides/text-generation),

            [images](/docs/guides/vision), and [audio](/docs/guides/audio).
          type: array
          minItems: 1
          items:
            $ref: '#/components/schemas/ChatCompletionRequestMessage'
        model:
          description: >-
            ID of the model to use. See the [model endpoint
            compatibility](/docs/models#model-endpoint-compatibility) table for
            details on which models work with the Chat API.
          example: gpt-4o
          anyOf:
            - type: string
            - type: string
              enum:
                - o1
                - o1-2024-12-17
                - o1-preview
                - o1-preview-2024-09-12
                - o1-mini
                - o1-mini-2024-09-12
                - gpt-4o
                - gpt-4o-2024-11-20
                - gpt-4o-2024-08-06
                - gpt-4o-2024-05-13
                - gpt-4o-audio-preview
                - gpt-4o-audio-preview-2024-10-01
                - gpt-4o-audio-preview-2024-12-17
                - gpt-4o-mini-audio-preview
                - gpt-4o-mini-audio-preview-2024-12-17
                - chatgpt-4o-latest
                - gpt-4o-mini
                - gpt-4o-mini-2024-07-18
                - gpt-4-turbo
                - gpt-4-turbo-2024-04-09
                - gpt-4-0125-preview
                - gpt-4-turbo-preview
                - gpt-4-1106-preview
                - gpt-4-vision-preview
                - gpt-4
                - gpt-4-0314
                - gpt-4-0613
                - gpt-4-32k
                - gpt-4-32k-0314
                - gpt-4-32k-0613
                - gpt-3.5-turbo
                - gpt-3.5-turbo-16k
                - gpt-3.5-turbo-0301
                - gpt-3.5-turbo-0613
                - gpt-3.5-turbo-1106
                - gpt-3.5-turbo-0125
                - gpt-3.5-turbo-16k-0613
          x-oaiTypeLabel: string
        store:
          type: boolean
          default: false
          nullable: true
          description: >
            Whether or not to store the output of this chat completion request
            for 

            use in our [model distillation](/docs/guides/distillation) or

            [evals](/docs/guides/evals) products.
        reasoning_effort:
          type: string
          enum:
            - low
            - medium
            - high
          default: medium
          description: >
            **o1 models only** 


            Constrains effort on reasoning for 

            [reasoning
            models](https://platform.openai.com/docs/guides/reasoning).

            Currently supported values are `low`, `medium`, and `high`. Reducing

            reasoning effort can result in faster responses and fewer tokens
            used

            on reasoning in a response.
        metadata:
          type: object
          nullable: true
          description: |
            Developer-defined tags and values used for filtering completions
            in the [dashboard](https://platform.openai.com/chat-completions).
          additionalProperties:
            type: string
        frequency_penalty:
          type: number
          default: 0
          minimum: -2
          maximum: 2
          nullable: true
          description: >
            Number between -2.0 and 2.0. Positive values penalize new tokens
            based on

            their existing frequency in the text so far, decreasing the model's

            likelihood to repeat the same line verbatim.
        logit_bias:
          type: object
          x-oaiTypeLabel: map
          default: null
          nullable: true
          additionalProperties:
            type: integer
          description: >
            Modify the likelihood of specified tokens appearing in the
            completion.


            Accepts a JSON object that maps tokens (specified by their token ID
            in the

            tokenizer) to an associated bias value from -100 to 100.
            Mathematically,

            the bias is added to the logits generated by the model prior to
            sampling.

            The exact effect will vary per model, but values between -1 and 1
            should

            decrease or increase likelihood of selection; values like -100 or
            100

            should result in a ban or exclusive selection of the relevant token.
        logprobs:
          description: >
            Whether to return log probabilities of the output tokens or not. If
            true,

            returns the log probabilities of each output token returned in the

            `content` of `message`.
          type: boolean
          default: false
          nullable: true
        top_logprobs:
          description: >
            An integer between 0 and 20 specifying the number of most likely
            tokens to

            return at each token position, each with an associated log
            probability.

            `logprobs` must be set to `true` if this parameter is used.
          type: integer
          minimum: 0
          maximum: 20
          nullable: true
        max_tokens:
          description: >
            The maximum number of [tokens](/tokenizer) that can be generated in
            the

            chat completion. This value can be used to control

            [costs](https://openai.com/api/pricing/) for text generated via API.


            This value is now deprecated in favor of `max_completion_tokens`,
            and is

            not compatible with [o1 series models](/docs/guides/reasoning).
          type: integer
          nullable: true
          deprecated: true
        max_completion_tokens:
          description: >
            An upper bound for the number of tokens that can be generated for a
            completion, including visible output tokens and [reasoning
            tokens](/docs/guides/reasoning).
          type: integer
          nullable: true
        'n':
          type: integer
          minimum: 1
          maximum: 128
          default: 1
          example: 1
          nullable: true
          description: >-
            How many chat completion choices to generate for each input message.
            Note that you will be charged based on the number of generated
            tokens across all of the choices. Keep `n` as `1` to minimize costs.
        modalities:
          $ref: '#/components/schemas/ChatCompletionModalities'
        prediction:
          nullable: true
          x-oaiExpandable: true
          description: >
            Configuration for a [Predicted
            Output](/docs/guides/predicted-outputs),

            which can greatly improve response times when large parts of the
            model

            response are known ahead of time. This is most common when you are

            regenerating a file with only minor changes to most of the content.
          oneOf:
            - $ref: '#/components/schemas/PredictionContent'
        audio:
          type: object
          nullable: true
          description: >
            Parameters for audio output. Required when audio output is requested
            with

            `modalities: ["audio"]`. [Learn more](/docs/guides/audio).
          required:
            - voice
            - format
          x-oaiExpandable: true
          properties:
            voice:
              type: string
              enum:
                - alloy
                - ash
                - ballad
                - coral
                - echo
                - sage
                - shimmer
                - verse
              description: >
                The voice the model uses to respond. Supported voices are `ash`,
                `ballad`, `coral`, `sage`, and `verse` (also supported but not
                recommended are `alloy`, `echo`, and `shimmer`; these voices are
                less expressive).
            format:
              type: string
              enum:
                - wav
                - mp3
                - flac
                - opus
                - pcm16
              description: >
                Specifies the output audio format. Must be one of `wav`, `mp3`,
                `flac`,

                `opus`, or `pcm16`.
        presence_penalty:
          type: number
          default: 0
          minimum: -2
          maximum: 2
          nullable: true
          description: >
            Number between -2.0 and 2.0. Positive values penalize new tokens
            based on

            whether they appear in the text so far, increasing the model's
            likelihood

            to talk about new topics.
        response_format:
          description: >
            An object specifying the format that the model must output.


            Setting to `{ "type": "json_schema", "json_schema": {...} }` enables

            Structured Outputs which ensures the model will match your supplied
            JSON

            schema. Learn more in the [Structured Outputs

            guide](/docs/guides/structured-outputs).


            Setting to `{ "type": "json_object" }` enables JSON mode, which
            ensures

            the message the model generates is valid JSON.


            **Important:** when using JSON mode, you **must** also instruct the
            model

            to produce JSON yourself via a system or user message. Without this,
            the

            model may generate an unending stream of whitespace until the
            generation

            reaches the token limit, resulting in a long-running and seemingly
            "stuck"

            request. Also note that the message content may be partially cut off
            if

            `finish_reason="length"`, which indicates the generation exceeded

            `max_tokens` or the conversation exceeded the max context length.
          oneOf:
            - $ref: '#/components/schemas/ResponseFormatText'
            - $ref: '#/components/schemas/ResponseFormatJsonObject'
            - $ref: '#/components/schemas/ResponseFormatJsonSchema'
          x-oaiExpandable: true
        seed:
          type: integer
          minimum: -9223372036854776000
          maximum: 9223372036854776000
          nullable: true
          description: >
            This feature is in Beta.

            If specified, our system will make a best effort to sample
            deterministically, such that repeated requests with the same `seed`
            and parameters should return the same result.

            Determinism is not guaranteed, and you should refer to the
            `system_fingerprint` response parameter to monitor changes in the
            backend.
          x-oaiMeta:
            beta: true
        service_tier:
          description: >
            Specifies the latency tier to use for processing the request. This
            parameter is relevant for customers subscribed to the scale tier
            service:
              - If set to 'auto', and the Project is Scale tier enabled, the system will utilize scale tier credits until they are exhausted.
              - If set to 'auto', and the Project is not Scale tier enabled, the request will be processed using the default service tier with a lower uptime SLA and no latency guarentee.
              - If set to 'default', the request will be processed using the default service tier with a lower uptime SLA and no latency guarentee.
              - When not set, the default behavior is 'auto'.

              When this parameter is set, the response body will include the `service_tier` utilized.
          type: string
          enum:
            - auto
            - default
          nullable: true
          default: auto
        stop:
          description: |
            Up to 4 sequences where the API will stop generating further tokens.
          default: null
          oneOf:
            - type: string
              nullable: true
            - type: array
              minItems: 1
              maxItems: 4
              items:
                type: string
        stream:
          description: >
            If set, partial message deltas will be sent, like in ChatGPT. Tokens
            will be sent as data-only [server-sent
            events](https://developer.mozilla.org/en-US/docs/Web/API/Server-sent_events/Using_server-sent_events#Event_stream_format)
            as they become available, with the stream terminated by a `data:
            [DONE]` message. [Example Python
            code](https://cookbook.openai.com/examples/how_to_stream_completions).
          type: boolean
          nullable: true
          default: false
        stream_options:
          $ref: '#/components/schemas/ChatCompletionStreamOptions'
        temperature:
          type: number
          minimum: 0
          maximum: 2
          default: 1
          example: 1
          nullable: true
          description: >
            What sampling temperature to use, between 0 and 2. Higher values
            like 0.8 will make the output more random, while lower values like
            0.2 will make it more focused and deterministic.

            We generally recommend altering this or `top_p` but not both.
        top_p:
          type: number
          minimum: 0
          maximum: 1
          default: 1
          example: 1
          nullable: true
          description: >
            An alternative to sampling with temperature, called nucleus
            sampling,

            where the model considers the results of the tokens with top_p
            probability

            mass. So 0.1 means only the tokens comprising the top 10%
            probability mass

            are considered.


            We generally recommend altering this or `temperature` but not both.
        tools:
          type: array
          description: >
            A list of tools the model may call. Currently, only functions are
            supported as a tool. Use this to provide a list of functions the
            model may generate JSON inputs for. A max of 128 functions are
            supported.
          items:
            $ref: '#/components/schemas/ChatCompletionTool'
        tool_choice:
          $ref: '#/components/schemas/ChatCompletionToolChoiceOption'
        parallel_tool_calls:
          $ref: '#/components/schemas/ParallelToolCalls'
        user:
          type: string
          example: user-1234
          description: >
            A unique identifier representing your end-user, which can help
            OpenAI to monitor and detect abuse. [Learn
            more](/docs/guides/safety-best-practices#end-user-ids).
        function_call:
          deprecated: true
          description: >
            Deprecated in favor of `tool_choice`.


            Controls which (if any) function is called by the model.


            `none` means the model will not call a function and instead
            generates a

            message.


            `auto` means the model can pick between generating a message or
            calling a

            function.


            Specifying a particular function via `{"name": "my_function"}`
            forces the

            model to call that function.


            `none` is the default when no functions are present. `auto` is the
            default

            if functions are present.
          oneOf:
            - type: string
              description: >
                `none` means the model will not call a function and instead
                generates a message. `auto` means the model can pick between
                generating a message or calling a function.
              enum:
                - none
                - auto
            - $ref: '#/components/schemas/ChatCompletionFunctionCallOption'
          x-oaiExpandable: true
        functions:
          deprecated: true
          description: |
            Deprecated in favor of `tools`.

            A list of functions the model may generate JSON inputs for.
          type: array
          minItems: 1
          maxItems: 128
          items:
            $ref: '#/components/schemas/ChatCompletionFunctions'
      required:
        - messages
    EnkryptCreateChatCompletionResponse:
      title: EnkryptCreateChatCompletionResponse
      allOf:
        - $ref: '#/components/schemas/CreateCompletionResponse'
        - properties:
            enkrypt_policy_detections:
              type: object
              description: The policy detections for the completion.
              properties:
                input_guardrails:
                  $ref: '#/components/schemas/GuardrailsDetectionResponse'
                output_guardrails:
                  $ref: '#/components/schemas/GuardrailsDetectionResponse'
    ChatCompletionRequestMessage:
      oneOf:
        - $ref: '#/components/schemas/ChatCompletionRequestDeveloperMessage'
        - $ref: '#/components/schemas/ChatCompletionRequestSystemMessage'
        - $ref: '#/components/schemas/ChatCompletionRequestUserMessage'
        - $ref: '#/components/schemas/ChatCompletionRequestAssistantMessage'
        - $ref: '#/components/schemas/ChatCompletionRequestToolMessage'
        - $ref: '#/components/schemas/ChatCompletionRequestFunctionMessage'
      x-oaiExpandable: true
    ChatCompletionModalities:
      type: array
      nullable: true
      description: >
        Output types that you would like the model to generate for this request.

        Most models are capable of generating text, which is the default:


        `["text"]`


        The `gpt-4o-audio-preview` model can also be used to [generate
        audio](/docs/guides/audio). To

        request that this model generate both text and audio responses, you can

        use:


        `["text", "audio"]`
      items:
        type: string
        enum:
          - text
          - audio
    PredictionContent:
      type: object
      title: Static Content
      description: >
        Static predicted output content, such as the content of a text file that
        is

        being regenerated.
      required:
        - type
        - content
      properties:
        type:
          type: string
          enum:
            - content
          description: |
            The type of the predicted content you want to provide. This type is
            currently always `content`.
        content:
          x-oaiExpandable: true
          description: >
            The content that should be matched when generating a model response.

            If generated tokens would match this content, the entire model
            response

            can be returned much more quickly.
          oneOf:
            - type: string
              title: Text content
              description: |
                The content used for a Predicted Output. This is often the
                text of a file you are regenerating with minor changes.
            - type: array
              description: >-
                An array of content parts with a defined type. Supported options
                differ based on the [model](/docs/models) being used to generate
                the response. Can contain text inputs.
              title: Array of content parts
              items:
                $ref: >-
                  #/components/schemas/ChatCompletionRequestMessageContentPartText
              minItems: 1
    ResponseFormatText:
      type: object
      properties:
        type:
          type: string
          description: 'The type of response format being defined: `text`'
          enum:
            - text
      required:
        - type
    ResponseFormatJsonObject:
      type: object
      properties:
        type:
          type: string
          description: 'The type of response format being defined: `json_object`'
          enum:
            - json_object
      required:
        - type
    ResponseFormatJsonSchema:
      type: object
      properties:
        type:
          type: string
          description: 'The type of response format being defined: `json_schema`'
          enum:
            - json_schema
        json_schema:
          type: object
          properties:
            description:
              type: string
              description: >-
                A description of what the response format is for, used by the
                model to determine how to respond in the format.
            name:
              type: string
              description: >-
                The name of the response format. Must be a-z, A-Z, 0-9, or
                contain underscores and dashes, with a maximum length of 64.
            schema:
              $ref: '#/components/schemas/ResponseFormatJsonSchemaSchema'
            strict:
              type: boolean
              nullable: true
              default: false
              description: >-
                Whether to enable strict schema adherence when generating the
                output. If set to true, the model will always follow the exact
                schema defined in the `schema` field. Only a subset of JSON
                Schema is supported when `strict` is `true`. To learn more, read
                the [Structured Outputs guide](/docs/guides/structured-outputs).
          required:
            - type
            - name
      required:
        - type
        - json_schema
    ChatCompletionStreamOptions:
      description: >
        Options for streaming response. Only set this when you set `stream:
        true`.
      type: object
      nullable: true
      default: null
      properties:
        include_usage:
          type: boolean
          description: >
            If set, an additional chunk will be streamed before the `data:
            [DONE]` message. The `usage` field on this chunk shows the token
            usage statistics for the entire request, and the `choices` field
            will always be an empty array. All other chunks will also include a
            `usage` field, but with a null value.
    ChatCompletionTool:
      type: object
      properties:
        type:
          type: string
          enum:
            - function
          description: The type of the tool. Currently, only `function` is supported.
        function:
          $ref: '#/components/schemas/FunctionObject'
      required:
        - type
        - function
    ChatCompletionToolChoiceOption:
      description: >
        Controls which (if any) tool is called by the model.

        `none` means the model will not call any tool and instead generates a
        message.

        `auto` means the model can pick between generating a message or calling
        one or more tools.

        `required` means the model must call one or more tools.

        Specifying a particular tool via `{"type": "function", "function":
        {"name": "my_function"}}` forces the model to call that tool.


        `none` is the default when no tools are present. `auto` is the default
        if tools are present.
      oneOf:
        - type: string
          description: >
            `none` means the model will not call any tool and instead generates
            a message. `auto` means the model can pick between generating a
            message or calling one or more tools. `required` means the model
            must call one or more tools.
          enum:
            - none
            - auto
            - required
        - $ref: '#/components/schemas/ChatCompletionNamedToolChoice'
      x-oaiExpandable: true
    ParallelToolCalls:
      description: >-
        Whether to enable [parallel function
        calling](/docs/guides/function-calling#configuring-parallel-function-calling)
        during tool use.
      type: boolean
      default: true
    ChatCompletionFunctionCallOption:
      type: object
      description: >
        Specifying a particular function via `{"name": "my_function"}` forces
        the model to call that function.
      properties:
        name:
          type: string
          description: The name of the function to call.
      required:
        - name
    ChatCompletionFunctions:
      type: object
      deprecated: true
      properties:
        description:
          type: string
          description: >-
            A description of what the function does, used by the model to choose
            when and how to call the function.
        name:
          type: string
          description: >-
            The name of the function to be called. Must be a-z, A-Z, 0-9, or
            contain underscores and dashes, with a maximum length of 64.
        parameters:
          $ref: '#/components/schemas/FunctionParameters'
      required:
        - name
    CreateCompletionResponse:
      type: object
      description: >
        Represents a completion response from the API. Note: both the streamed
        and non-streamed response objects share the same shape (unlike the chat
        endpoint).
      properties:
        id:
          type: string
          description: A unique identifier for the completion.
        choices:
          type: array
          description: >-
            The list of completion choices the model generated for the input
            prompt.
          items:
            type: object
            required:
              - finish_reason
              - index
              - logprobs
              - text
            properties:
              finish_reason:
                type: string
                description: >
                  The reason the model stopped generating tokens. This will be
                  `stop` if the model hit a natural stop point or a provided
                  stop sequence,

                  `length` if the maximum number of tokens specified in the
                  request was reached,

                  or `content_filter` if content was omitted due to a flag from
                  our content filters.
                enum:
                  - stop
                  - length
                  - content_filter
              index:
                type: integer
              logprobs:
                type: object
                nullable: true
                properties:
                  text_offset:
                    type: array
                    items:
                      type: integer
                  token_logprobs:
                    type: array
                    items:
                      type: number
                  tokens:
                    type: array
                    items:
                      type: string
                  top_logprobs:
                    type: array
                    items:
                      type: object
                      additionalProperties:
                        type: number
              text:
                type: string
        created:
          type: integer
          description: The Unix timestamp (in seconds) of when the completion was created.
        model:
          type: string
          description: The model used for completion.
        system_fingerprint:
          type: string
          description: >
            This fingerprint represents the backend configuration that the model
            runs with.


            Can be used in conjunction with the `seed` request parameter to
            understand when backend changes have been made that might impact
            determinism.
        object:
          type: string
          description: The object type, which is always "text_completion"
          enum:
            - text_completion
        usage:
          $ref: '#/components/schemas/CompletionUsage'
      required:
        - id
        - object
        - created
        - model
        - choices
      x-oaiMeta:
        name: The completion object
        legacy: true
        example: |
          {
            "id": "cmpl-uqkvlQyYK7bGYrRHQ0eXlWi7",
            "object": "text_completion",
            "created": 1589478378,
            "model": "gpt-4-turbo",
            "choices": [
              {
                "text": "\n\nThis is indeed a test",
                "index": 0,
                "logprobs": null,
                "finish_reason": "length"
              }
            ],
            "usage": {
              "prompt_tokens": 5,
              "completion_tokens": 7,
              "total_tokens": 12
            }
          }
    GuardrailsDetectionResponse:
      title: GuardrailsDetectionResponse
      type: object
      required:
        - summary
        - details
      properties:
        summary:
          $ref: '#/components/schemas/GuardrailsDetectionResponseSummary'
        details:
          $ref: '#/components/schemas/GuardrailsDetectionResponseDetails'
        result_message:
          type: string
          nullable: true
          title: Result Message
          description: >-
            Block message when a block-type detector triggers (custom or
            built-in default), revised text when only revise-type detectors
            trigger, or null when no detections fire.
    ChatCompletionRequestDeveloperMessage:
      type: object
      title: Developer message
      description: >
        Developer-provided instructions that the model should follow, regardless
        of

        messages sent by the user. With o1 models and newer, `developer`
        messages

        replace the previous `system` messages.
      properties:
        content:
          description: The contents of the developer message.
          oneOf:
            - type: string
              description: The contents of the developer message.
              title: Text content
            - type: array
              description: >-
                An array of content parts with a defined type. For developer
                messages, only type `text` is supported.
              title: Array of content parts
              items:
                $ref: >-
                  #/components/schemas/ChatCompletionRequestMessageContentPartText
              minItems: 1
        role:
          type: string
          enum:
            - developer
          description: The role of the messages author, in this case `developer`.
        name:
          type: string
          description: >-
            An optional name for the participant. Provides the model information
            to differentiate between participants of the same role.
      required:
        - content
        - role
    ChatCompletionRequestSystemMessage:
      type: object
      title: System message
      description: >
        Developer-provided instructions that the model should follow, regardless
        of

        messages sent by the user. With o1 models and newer, use `developer`
        messages

        for this purpose instead.
      properties:
        content:
          description: The contents of the system message.
          oneOf:
            - type: string
              description: The contents of the system message.
              title: Text content
            - type: array
              description: >-
                An array of content parts with a defined type. For system
                messages, only type `text` is supported.
              title: Array of content parts
              items:
                $ref: >-
                  #/components/schemas/ChatCompletionRequestSystemMessageContentPart
              minItems: 1
        role:
          type: string
          enum:
            - system
          description: The role of the messages author, in this case `system`.
        name:
          type: string
          description: >-
            An optional name for the participant. Provides the model information
            to differentiate between participants of the same role.
      required:
        - content
        - role
    ChatCompletionRequestUserMessage:
      type: object
      title: User message
      description: |
        Messages sent by an end user, containing prompts or additional context
        information.
      properties:
        content:
          description: |
            The contents of the user message.
          oneOf:
            - type: string
              description: The text contents of the message.
              title: Text content
            - type: array
              description: >-
                An array of content parts with a defined type. Supported options
                differ based on the [model](/docs/models) being used to generate
                the response. Can contain text, image, or audio inputs.
              title: Array of content parts
              items:
                $ref: >-
                  #/components/schemas/ChatCompletionRequestUserMessageContentPart
              minItems: 1
          x-oaiExpandable: true
        role:
          type: string
          enum:
            - user
          description: The role of the messages author, in this case `user`.
        name:
          type: string
          description: >-
            An optional name for the participant. Provides the model information
            to differentiate between participants of the same role.
      required:
        - content
        - role
    ChatCompletionRequestAssistantMessage:
      type: object
      title: Assistant message
      description: |
        Messages sent by the model in response to user messages.
      properties:
        content:
          x-oaiExpandable: true
          nullable: true
          oneOf:
            - type: string
              description: The contents of the assistant message.
              title: Text content
            - type: array
              description: >-
                An array of content parts with a defined type. Can be one or
                more of type `text`, or exactly one of type `refusal`.
              title: Array of content parts
              items:
                $ref: >-
                  #/components/schemas/ChatCompletionRequestAssistantMessageContentPart
              minItems: 1
          description: >
            The contents of the assistant message. Required unless `tool_calls`
            or `function_call` is specified.
        refusal:
          nullable: true
          type: string
          description: The refusal message by the assistant.
        role:
          type: string
          enum:
            - assistant
          description: The role of the messages author, in this case `assistant`.
        name:
          type: string
          description: >-
            An optional name for the participant. Provides the model information
            to differentiate between participants of the same role.
        audio:
          type: object
          nullable: true
          x-oaiExpandable: true
          description: |
            Data about a previous audio response from the model. 
            [Learn more](/docs/guides/audio).
          required:
            - id
          properties:
            id:
              type: string
              description: |
                Unique identifier for a previous audio response from the model.
        tool_calls:
          $ref: '#/components/schemas/ChatCompletionMessageToolCalls'
        function_call:
          type: object
          deprecated: true
          description: >-
            Deprecated and replaced by `tool_calls`. The name and arguments of a
            function that should be called, as generated by the model.
          nullable: true
          properties:
            arguments:
              type: string
              description: >-
                The arguments to call the function with, as generated by the
                model in JSON format. Note that the model does not always
                generate valid JSON, and may hallucinate parameters not defined
                by your function schema. Validate the arguments in your code
                before calling your function.
            name:
              type: string
              description: The name of the function to call.
          required:
            - arguments
            - name
      required:
        - role
    ChatCompletionRequestToolMessage:
      type: object
      title: Tool message
      properties:
        role:
          type: string
          enum:
            - tool
          description: The role of the messages author, in this case `tool`.
        content:
          oneOf:
            - type: string
              description: The contents of the tool message.
              title: Text content
            - type: array
              description: >-
                An array of content parts with a defined type. For tool
                messages, only type `text` is supported.
              title: Array of content parts
              items:
                $ref: >-
                  #/components/schemas/ChatCompletionRequestToolMessageContentPart
              minItems: 1
          description: The contents of the tool message.
        tool_call_id:
          type: string
          description: Tool call that this message is responding to.
      required:
        - role
        - content
        - tool_call_id
    ChatCompletionRequestFunctionMessage:
      type: object
      title: Function message
      deprecated: true
      properties:
        role:
          type: string
          enum:
            - function
          description: The role of the messages author, in this case `function`.
        content:
          nullable: true
          type: string
          description: The contents of the function message.
        name:
          type: string
          description: The name of the function to call.
      required:
        - role
        - content
        - name
    ChatCompletionRequestMessageContentPartText:
      type: object
      title: Text content part
      description: |
        Learn about [text inputs](/docs/guides/text-generation).
      properties:
        type:
          type: string
          enum:
            - text
          description: The type of the content part.
        text:
          type: string
          description: The text content.
      required:
        - type
        - text
    ResponseFormatJsonSchemaSchema:
      type: object
      description: The schema for the response format, described as a JSON Schema object.
      additionalProperties: true
    FunctionObject:
      type: object
      properties:
        description:
          type: string
          description: >-
            A description of what the function does, used by the model to choose
            when and how to call the function.
        name:
          type: string
          description: >-
            The name of the function to be called. Must be a-z, A-Z, 0-9, or
            contain underscores and dashes, with a maximum length of 64.
        parameters:
          $ref: '#/components/schemas/FunctionParameters'
        strict:
          type: boolean
          nullable: true
          default: false
          description: >-
            Whether to enable strict schema adherence when generating the
            function call. If set to true, the model will follow the exact
            schema defined in the `parameters` field. Only a subset of JSON
            Schema is supported when `strict` is `true`. Learn more about
            Structured Outputs in the [function calling
            guide](docs/guides/function-calling).
      required:
        - name
    ChatCompletionNamedToolChoice:
      type: object
      description: >-
        Specifies a tool the model should use. Use to force the model to call a
        specific function.
      properties:
        type:
          type: string
          enum:
            - function
          description: The type of the tool. Currently, only `function` is supported.
        function:
          type: object
          properties:
            name:
              type: string
              description: The name of the function to call.
          required:
            - name
      required:
        - type
        - function
    FunctionParameters:
      type: object
      description: >-
        The parameters the functions accepts, described as a JSON Schema object.
        See the [guide](/docs/guides/function-calling) for examples, and the
        [JSON Schema
        reference](https://json-schema.org/understanding-json-schema/) for
        documentation about the format. 


        Omitting `parameters` defines a function with an empty parameter list.
      additionalProperties: true
    CompletionUsage:
      type: object
      description: Usage statistics for the completion request.
      properties:
        completion_tokens:
          type: integer
          description: Number of tokens in the generated completion.
        prompt_tokens:
          type: integer
          description: Number of tokens in the prompt.
        total_tokens:
          type: integer
          description: Total number of tokens used in the request (prompt + completion).
        completion_tokens_details:
          type: object
          description: Breakdown of tokens used in a completion.
          properties:
            accepted_prediction_tokens:
              type: integer
              description: |
                When using Predicted Outputs, the number of tokens in the
                prediction that appeared in the completion.
            audio_tokens:
              type: integer
              description: Audio input tokens generated by the model.
            reasoning_tokens:
              type: integer
              description: Tokens generated by the model for reasoning.
            rejected_prediction_tokens:
              type: integer
              description: >
                When using Predicted Outputs, the number of tokens in the

                prediction that did not appear in the completion. However, like

                reasoning tokens, these tokens are still counted in the total

                completion tokens for purposes of billing, output, and context
                window

                limits.
        prompt_tokens_details:
          type: object
          description: Breakdown of tokens used in the prompt.
          properties:
            audio_tokens:
              type: integer
              description: Audio input tokens present in the prompt.
            cached_tokens:
              type: integer
              description: Cached tokens present in the prompt.
      required:
        - prompt_tokens
        - completion_tokens
        - total_tokens
    GuardrailsDetectionResponseSummary:
      type: object
      title: GuardrailsDetectionResponseSummary
      properties:
        nsfw:
          type: integer
          title: NSFW Count
          example: 0
        toxicity:
          type: array
          title: Toxicity Categories
          items:
            type: string
          example:
            - toxicity
            - severe_toxicity
            - obscene
            - threat
            - insult
            - identity_hate
        pii:
          type: integer
          title: PII Count
          example: 0
        injection_attack:
          type: integer
          title: Injection Attack Count
          example: 1
        keyword_detected:
          type: integer
          title: Keyword Detected Count
          example: 0
        system_prompt_similarity:
          type: integer
          title: System Prompt Similarity
          example: 0
        copyright_ip_similarity:
          type: integer
          title: Copyright/IP Similarity
          example: 0
        policy_violation:
          type: integer
          title: Policy Adherence Count
          example: 0
        bias:
          type: integer
          title: Bias Count
          example: 0
        sponge_attack:
          type: integer
          title: Sponge Attack Detected or not
          example: 0
    GuardrailsDetectionResponseDetails:
      type: object
      title: GuardrailsDetectionResponseDetails
      properties:
        nsfw:
          type: object
          title: NSFW Details
          properties:
            sfw:
              type: number
              title: Safe for Work Score
              example: 0.000395895738620311
            nsfw:
              type: number
              title: Not Safe for Work Score
              example: 0.9996041054725647
            compliance_mapping:
              type: object
              title: Compliance Mapping
              description: Mapping of detection to regulatory compliance frameworks
              properties:
                owasp_llm_2025:
                  type: array
                  items:
                    type: string
                  title: OWASP LLM Top 10 2025
                mitre_atlas:
                  type: array
                  items:
                    type: string
                  title: MITRE ATLAS
                nist_ai_rmf:
                  type: array
                  items:
                    type: string
                  title: NIST AI Risk Management Framework
                eu_ai_act:
                  type: array
                  items:
                    type: string
                  title: EU AI Act
                iso_iec_standards:
                  type: array
                  items:
                    type: string
                  title: ISO/IEC Standards
        toxicity:
          type: object
          title: Toxicity Details
          properties:
            toxicity:
              type: number
              title: Toxicity Score
              example: 0.000395895738620311
            severe_toxicity:
              type: number
              format: float
              title: Severe Toxicity Score
              example: 0.000395895738620311
            obscene:
              type: number
              title: Obscenity Score
              example: 0.000395895738620311
            threat:
              type: number
              title: Threat Score
              example: 0.000395895738620311
            insult:
              type: number
              title: Insult Score
              example: 0.000395895738620311
            identity_hate:
              type: number
              title: Identity Hate Score
              example: 0.000395895738620311
            compliance_mapping:
              type: object
              title: Compliance Mapping
              description: Mapping of detection to regulatory compliance frameworks
              properties:
                owasp_llm_2025:
                  type: array
                  items:
                    type: string
                  title: OWASP LLM Top 10 2025
                mitre_atlas:
                  type: array
                  items:
                    type: string
                  title: MITRE ATLAS
                nist_ai_rmf:
                  type: array
                  items:
                    type: string
                  title: NIST AI Risk Management Framework
                eu_ai_act:
                  type: array
                  items:
                    type: string
                  title: EU AI Act
                iso_iec_standards:
                  type: array
                  items:
                    type: string
                  title: ISO/IEC Standards
        pii:
          type: object
          title: PII Details
          properties:
            secrets:
              type: object
              title: Secrets Detected
            pii:
              type: object
              title: PII Details
            ip_address:
              type: object
              title: IP Addresses Detected
            url:
              type: object
              title: URLs Detected
            compliance_mapping:
              type: object
              title: Compliance Mapping
              description: Mapping of detection to regulatory compliance frameworks
              properties:
                owasp_llm_2025:
                  type: array
                  items:
                    type: string
                  title: OWASP LLM Top 10 2025
                mitre_atlas:
                  type: array
                  items:
                    type: string
                  title: MITRE ATLAS
                nist_ai_rmf:
                  type: array
                  items:
                    type: string
                  title: NIST AI Risk Management Framework
                eu_ai_act:
                  type: array
                  items:
                    type: string
                  title: EU AI Act
                iso_iec_standards:
                  type: array
                  items:
                    type: string
                  title: ISO/IEC Standards
        injection_attack:
          type: object
          title: Injection Attack Details
          properties:
            safe:
              type: number
              title: Safe Score
              example: '0.000004'
            attack:
              type: number
              title: Attack Score
              example: '0.999996'
            most_unsafe_content:
              type: string
              title: Most Unsafe Content
              description: The most unsafe content detected in the input
            compliance_mapping:
              type: object
              title: Compliance Mapping
              description: Mapping of detection to regulatory compliance frameworks
              properties:
                owasp_llm_2025:
                  type: array
                  items:
                    type: string
                  title: OWASP LLM Top 10 2025
                mitre_atlas:
                  type: array
                  items:
                    type: string
                  title: MITRE ATLAS
                nist_ai_rmf:
                  type: array
                  items:
                    type: string
                  title: NIST AI Risk Management Framework
                eu_ai_act:
                  type: array
                  items:
                    type: string
                  title: EU AI Act
                iso_iec_standards:
                  type: array
                  items:
                    type: string
                  title: ISO/IEC Standards
        keyword_detector:
          type: object
          title: Keyword Detector Details
          properties:
            detected_keywords:
              type: array
              title: Detected Keywords
              items:
                type: string
            detected_counts:
              type: object
              title: Detected Counts
              example:
                keyword1: 1
                keyword2: 2
            redacted_text:
              type: string
              title: Redacted Text
        system_prompt:
          type: object
          title: System Prompt Similarity
          properties:
            similarity_score:
              type: integer
              title: Similarity Score
              example: 0
            compliance_mapping:
              type: object
              title: Compliance Mapping
              description: Mapping of detection to regulatory compliance frameworks
              properties:
                owasp_llm_2025:
                  type: array
                  items:
                    type: string
                  title: OWASP LLM Top 10 2025
                mitre_atlas:
                  type: array
                  items:
                    type: string
                  title: MITRE ATLAS
                nist_ai_rmf:
                  type: array
                  items:
                    type: string
                  title: NIST AI Risk Management Framework
                eu_ai_act:
                  type: array
                  items:
                    type: string
                  title: EU AI Act
                iso_iec_standards:
                  type: array
                  items:
                    type: string
                  title: ISO/IEC Standards
        copyright_ip:
          type: object
          title: Copyright/IP Similarity Details
          properties:
            similarity_score:
              type: integer
              title: Similarity Score
              example: 0
            compliance_mapping:
              type: object
              title: Compliance Mapping
              description: Mapping of detection to regulatory compliance frameworks
              properties:
                owasp_llm_2025:
                  type: array
                  items:
                    type: string
                  title: OWASP LLM Top 10 2025
                mitre_atlas:
                  type: array
                  items:
                    type: string
                  title: MITRE ATLAS
                nist_ai_rmf:
                  type: array
                  items:
                    type: string
                  title: NIST AI Risk Management Framework
                eu_ai_act:
                  type: array
                  items:
                    type: string
                  title: EU AI Act
                iso_iec_standards:
                  type: array
                  items:
                    type: string
                  title: ISO/IEC Standards
        policy_violation:
          type: object
          title: Policy Adherence Details
          properties:
            violating_policy:
              type: string
              title: Violating Policy
            explanation:
              type: string
              title: Explanation
        bias:
          type: object
          title: Bias Details
          properties:
            bias_detected:
              type: boolean
              title: Bias Detected
            biased_text:
              type: string
              title: Biased Text
            debiased_text:
              type: string
              title: Debiased Text
            compliance_mapping:
              type: object
              title: Compliance Mapping
              description: Mapping of detection to regulatory compliance frameworks
              properties:
                owasp_llm_2025:
                  type: array
                  items:
                    type: string
                  title: OWASP LLM Top 10 2025
                mitre_atlas:
                  type: array
                  items:
                    type: string
                  title: MITRE ATLAS
                nist_ai_rmf:
                  type: array
                  items:
                    type: string
                  title: NIST AI Risk Management Framework
                eu_ai_act:
                  type: array
                  items:
                    type: string
                  title: EU AI Act
                iso_iec_standards:
                  type: array
                  items:
                    type: string
                  title: ISO/IEC Standards
        sponge_attack:
          type: object
          title: Sponge Attack Details
          properties:
            sponge_attack_detected:
              type: boolean
              title: Sponge Attack Detected
              example: false
            compliance_mapping:
              type: object
              title: Compliance Mapping
              description: Mapping of detection to regulatory compliance frameworks
              properties:
                owasp_llm_2025:
                  type: array
                  items:
                    type: string
                  title: OWASP LLM Top 10 2025
                mitre_atlas:
                  type: array
                  items:
                    type: string
                  title: MITRE ATLAS
                nist_ai_rmf:
                  type: array
                  items:
                    type: string
                  title: NIST AI Risk Management Framework
                eu_ai_act:
                  type: array
                  items:
                    type: string
                  title: EU AI Act
                iso_iec_standards:
                  type: array
                  items:
                    type: string
                  title: ISO/IEC Standards
    ChatCompletionRequestSystemMessageContentPart:
      oneOf:
        - $ref: '#/components/schemas/ChatCompletionRequestMessageContentPartText'
      x-oaiExpandable: true
    ChatCompletionRequestUserMessageContentPart:
      oneOf:
        - $ref: '#/components/schemas/ChatCompletionRequestMessageContentPartText'
        - $ref: '#/components/schemas/ChatCompletionRequestMessageContentPartImage'
        - $ref: '#/components/schemas/ChatCompletionRequestMessageContentPartAudio'
      x-oaiExpandable: true
    ChatCompletionRequestAssistantMessageContentPart:
      oneOf:
        - $ref: '#/components/schemas/ChatCompletionRequestMessageContentPartText'
        - $ref: '#/components/schemas/ChatCompletionRequestMessageContentPartRefusal'
      x-oaiExpandable: true
    ChatCompletionMessageToolCalls:
      type: array
      description: The tool calls generated by the model, such as function calls.
      items:
        $ref: '#/components/schemas/ChatCompletionMessageToolCall'
    ChatCompletionRequestToolMessageContentPart:
      oneOf:
        - $ref: '#/components/schemas/ChatCompletionRequestMessageContentPartText'
      x-oaiExpandable: true
    ChatCompletionRequestMessageContentPartImage:
      type: object
      title: Image content part
      description: |
        Learn about [image inputs](/docs/guides/vision).
      properties:
        type:
          type: string
          enum:
            - image_url
          description: The type of the content part.
        image_url:
          type: object
          properties:
            url:
              type: string
              description: Either a URL of the image or the base64 encoded image data.
              format: uri
            detail:
              type: string
              description: >-
                Specifies the detail level of the image. Learn more in the
                [Vision
                guide](/docs/guides/vision#low-or-high-fidelity-image-understanding).
              enum:
                - auto
                - low
                - high
              default: auto
          required:
            - url
      required:
        - type
        - image_url
    ChatCompletionRequestMessageContentPartAudio:
      type: object
      title: Audio content part
      description: |
        Learn about [audio inputs](/docs/guides/audio).
      properties:
        type:
          type: string
          enum:
            - input_audio
          description: The type of the content part. Always `input_audio`.
        input_audio:
          type: object
          properties:
            data:
              type: string
              description: Base64 encoded audio data.
            format:
              type: string
              enum:
                - wav
                - mp3
              description: >
                The format of the encoded audio data. Currently supports "wav"
                and "mp3".
          required:
            - data
            - format
      required:
        - type
        - input_audio
    ChatCompletionRequestMessageContentPartRefusal:
      type: object
      title: Refusal content part
      properties:
        type:
          type: string
          enum:
            - refusal
          description: The type of the content part.
        refusal:
          type: string
          description: The refusal message generated by the model.
      required:
        - type
        - refusal
    ChatCompletionMessageToolCall:
      type: object
      properties:
        id:
          type: string
          description: The ID of the tool call.
        type:
          type: string
          enum:
            - function
          description: The type of the tool. Currently, only `function` is supported.
        function:
          type: object
          description: The function that the model called.
          properties:
            name:
              type: string
              description: The name of the function to call.
            arguments:
              type: string
              description: >-
                The arguments to call the function with, as generated by the
                model in JSON format. Note that the model does not always
                generate valid JSON, and may hallucinate parameters not defined
                by your function schema. Validate the arguments in your code
                before calling your function.
          required:
            - name
            - arguments
      required:
        - id
        - type
        - function
  securitySchemes:
    apiKeyAuth:
      type: apiKey
      in: header
      name: apikey

````